//+------------------------------------------------------------------+
//|                                                 ColorCandles.mq4 |
//|                                                    Copyright 2020|
//|                                                                  |
//+------------------------------------------------------------------+

// Copy/past jeanlouie button code part, forexfactory.com, 26 aug 2020
// - request for show/hide button

#property copyright "Copyright 2020."
#property version   "1.00"
#property description "Supported MA Methods >>" 
#property description "Simple" 
#property description "Exponential" 
#property description "Smoothed" 
#property description "Weighted" 
#property description "Triangular" 
#property strict
#property indicator_chart_window
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum mam
  {
   a=0, // Simple
   b=1, // Exponential
   c=2, // Smoothed
   d=3, // Weighted
   e=4  // Triangular
  };
//+------------------------------------------------------------------+
#property indicator_buffers 4
#property indicator_color1 RoyalBlue//wicks
#property indicator_color2 Red//wicks
#property indicator_color3 RoyalBlue // Candle Bodies
#property indicator_color4 Red // Candle Bodies
//---
input int Candle_MA_Period=34; // Candle MA Period
input int Candle_MA_Shift=0; // Candle MA Shift
input mam Candle_Typex=b; // Candle MA Method
input ENUM_APPLIED_PRICE Candle_MA_Price=0; // Candle Price
input int Candle_Shadow_Width=1;
input int Candle_Body_Width=3;

input string note_10        = "";                       // Button
input bool   btn_show       = True;                     //__ show
input string btn_pressed    = "Newfxtrader MA Candles"; //__ text
input int    btn_offset_x   = 10;                       //__ x
input int    btn_offset_y   = 20;                       //__ y
input int    btn_width      = 160;                      //__ width
input int    btn_height     = 25;                       //__ height
input int    btn_font_size  = 10;                       //__ font size
input color  btn_font_clr   = clrAqua;                  //__ font color
input color  btn_bg_color   = clrDarkSlateGray;         //__ bg color
input color  btn_border_clr = clrWhiteSmoke;            //__ border color

//---
int MA1=1;
int MA1_MODE=0;
int MA1_PRICE = 0;
int MA1_SHIFT = 0;
//--- indicator buffers
double Bar1[],Bar2[],Candle1[],Candle2[];
//---
int Candle_Type=Candle_Typex;
//---
double MA_1 (int i = 0){return(iMA(NULL,0,MA1,MA1_SHIFT,MA1_MODE, MA1_PRICE,i));}
double MA_2 (int i = 0){return(iMA(NULL,0,Candle_MA_Period,Candle_MA_Shift,Candle_Type, Candle_MA_Price,i));}
double MA_3 (int i = 0){return(iTma(iMA(NULL,0,1,Candle_MA_Shift,MODE_SMA,Candle_MA_Price,i),Candle_MA_Period,i));}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//Candle_Type = Candle_Typex;
   ChartSetInteger(0,CHART_MODE,CHART_LINE);
   ChartSetInteger(0,CHART_COLOR_CHART_LINE,clrNONE);
//---
   IndicatorShortName("MA Candles");
   IndicatorBuffers(4);
//---
   SetIndexBuffer(0,Bar1);
   SetIndexBuffer(1,Bar2);
   SetIndexBuffer(2,Candle1);
   SetIndexBuffer(3,Candle2);
//---
   SetIndexStyle(0,DRAW_HISTOGRAM,0,Candle_Shadow_Width);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,Candle_Shadow_Width);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,Candle_Body_Width);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,Candle_Body_Width);
//--- Data Window Truth Table: R up L is Red Candle up Low; R dn L is Red Candle down Low, etc,.
   SetIndexLabel(0,"R up L, R dn L, B up H, B dn H");
   SetIndexLabel(1,"R up H, R dn H, B up L, B dn L");
   SetIndexLabel(2,"R up O, R dn C, B up C, B dn O");
   SetIndexLabel(3,"R up C, R dn O, B up O, B dn C");
   
   if(btn_show){CreateButton();}
   else if(!btn_show){ObjectDelete(NULL,"Newfxtrader MA Candles btn");}
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   for(int i=MathMax(Bars-1-IndicatorCounted(),1); i>=0; i--)
     {
      double   Ma1 = MA_1(i);
      double   Ma2 = MA_2(i);
      double   Ma3 = MA_3(i);
      //---
      if(Candle_Typex<4)
        {
         if(Ma1>Ma2)
           {
            SetCandleColor(1,i);
           }
         else
           {
            if(Ma1<Ma2) SetCandleColor(2,i);
           }
        }
      else if(Candle_Typex>3)
        {
         if(Ma1>Ma3)
           {
            SetCandleColor(1,i);
           }
         else
           {
            if(Ma1<Ma3) SetCandleColor(2,i);
           }
        }
     }
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetCandleColor(int col,int i)
  {
   double high,low,bodyHigh,bodyLow;
//---
   bodyHigh= MathMax(Open[i],Close[i]);
   bodyLow = MathMin(Open[i],Close[i]);
   high= High[i];
   low = Low[i];
//---
   Bar1[i]    = EMPTY_VALUE;
   Bar2[i]    = EMPTY_VALUE;
   Candle1[i] = EMPTY_VALUE;
   Candle2[i] = EMPTY_VALUE;
//---
   switch(col)
     {
      case 1: Bar1[i] = high; Bar2[i] = low; Candle1[i] = bodyHigh; Candle2[i] = bodyLow; break;
      case 2: Bar2[i] = high; Bar1[i] = low; Candle2[i] = bodyHigh; Candle1[i] = bodyLow; break;
     }
  }
//---
double workTma[][1];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double iTma(double price,double period,int r,int instanceNo=0)
  {
   if(ArrayRange(workTma,0)!=Bars) ArrayResize(workTma,Bars); r=Bars-r-1;
//---
   workTma[r][instanceNo]=price;
//---
   double half = (period+1.0)/2.0;
   double sum  = price;
   double sumw = 1;
//---
   for(int k=1; k<period && (r-k)>=0; k++)
     {
      double weight=k+1; if(weight>half) weight=period-k;
      sumw  += weight;
      sum   += weight*workTma[r-k][instanceNo];
     }
   return(sum/sumw);
  }
//+------------------------------------------------------------------+

void CreateButton()
{
   ButtonCreate(NULL,"Newfxtrader MA Candles btn",0,btn_offset_x,btn_offset_y,btn_width,btn_height,CORNER_LEFT_UPPER,btn_pressed,"Arial",btn_font_size,btn_font_clr,btn_bg_color,btn_border_clr,false,true,false,false,0);
}

void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
{
   if (id == CHARTEVENT_OBJECT_CLICK && sparam=="Newfxtrader MA Candles btn") 
   { 
      if(ObjectGetInteger(0,"Newfxtrader MA Candles btn",OBJPROP_STATE)){for(int x=0; x<8; x++){SetIndexStyle(x,DRAW_NONE);}}
      if(!ObjectGetInteger(0,"Newfxtrader MA Candles btn",OBJPROP_STATE)){for(int x=0; x<8; x++){SetIndexStyle(x,DRAW_HISTOGRAM);}}
   }
}

bool ButtonCreate(const long              chart_ID=0,               // chart's ID
                  const string            name="Button",            // button name
                  const int               sub_window=0,             // subwindow index
                  const int               x=0,                      // X coordinate
                  const int               y=0,                      // Y coordinate
                  const int               width=50,                 // button width
                  const int               height=18,                // button height
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // chart corner for anchoring
                  const string            text="Button",            // text
                  const string            font="Arial",             // font
                  const int               font_size=10,             // font size
                  const color             clr=clrBlack,             // text color
                  const color             back_clr=C'236,233,216',  // background color
                  const color             border_clr=clrNONE,       // border color
                  const bool              state=false,              // pressed/released
                  const bool              back=false,               // in the background
                  const bool              selectable=true,      //object can be selected        
                  const bool              selection=false,          // highlight to move
                  const bool              hidden=false,              // hidden in the object list
                  const long              z_order=0)                // priority for mouse click
  {
   ResetLastError();
   ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0);
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   return(true);
  }

void OnDeinit(const int reason){ObjectDelete(0,"Newfxtrader MA Candles btn");}

